% protocol for checking explicit checks

% Responder with explicit checks
respcheck(A, B, L, C, K, M, [
        label_Responder(A,B,L,C,K,M),
        [
	recv([L, C]),
	send(C/pk(B)),
	recv([K/pk(A),K]),
	check(C=M+K),
	check(L=sha(M)),
	send([K, [C, L]]/pk(B))
        ]
	]).

% Responder without explicit checks
responder(A, B, L, C, K, [
        label_Responder(A,B,L,C,K),
        [
	recv([L, C]),
	send(C/pk(B)),
	recv([K/pk(A),K]),
	send([K, [C, L]]/pk(B))
        ]
	]).

% Semibundle 
% [_,[]] means 'finish this strand'
semibundle([Sa,Sb],[[_,[]],_],[a,b,e,m,k]):-
%	responder(a,b,sha(m), m+k, k, Sa),
%	responder(e,a,sha(m), m+k, k, Sb).
	respcheck(a,b, L, C1, k, m, Sa),
	respcheck(e,a, L, C2, k, m, Sb).






