% Needham-Schroeder commented specification
% 
% First the Initiator and Responder (and sometimes also Server) 
% strands have to be specified. 
% 
% In this file the (flawed) Needham-Schroeder protocol is specified:

% Initiator strand specification
initiator(A,B,Na,Nb,[ 
   [agent(A), apparent_party(B)],

   [		
   [send([A,Na]*pk(B)),		[]],	

   [recv([Na,Nb]*pk(A)),	[]], 

   [send(Nb*pk(B)),		[]]	
   ]		
 ]).

% Responder strand specification
responder(A,B,Na,Nb,[
   [agent(B), apparent_party(A)],

   [	
   [recv([A,Na]*pk(B)),		[]],

   [send([Na,Nb]*pk(A)),	[]],

   [recv(Nb*pk(B)),		[]]
   ]
 ]).


% Finally, a scenario (semibundle) is specified.

% Semibundle specification (same as #System in CASPER)
% semibundle/2: L: list of strands, 
%		K: initial intruder knowledge

semibundle([Init1,Resp1],[a,b,e]) :-
   initiator(a,B,na,Nb,Init1),
   responder(A,b,Na,nb,Resp1).

% invariant
invariant(and(secrecy(nb),not(equal(A,e)))).

